/***************************************************************************
                    TitlePage.h -  enter document title and author
                             -------------------                                         
    begin                : Thu Mar 11 20:50:53 MET 1999
                                           
    copyright            : (C) 1999,2000 by Ewald Arnold                         
    email                : ewald@ewald-arnold.de                                     
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef TitleDialog_included
#define TitleDialog_included

#include "TitlePageData.h"

class TitlePage : public TitlePageData
{
    Q_OBJECT

public:

    TitlePage
    (
        QString      title,
        QString      author,
        QWidget     *parent = NULL,
        const char  *name = NULL
    );

    virtual ~TitlePage();

    QString getTitle() { return title; }
    QString getAuthor() { return author; }

public slots:
    virtual void initFocus() const;

protected:
  void keyPressEvent( QKeyEvent *e );

protected slots:

    virtual void slotTitleChanged(EA_QTSTR);
    virtual void slotAuthorChanged(EA_QTSTR);

private:

    QString title;
    QString author;
};

#endif // TitlePage_included
